JdoTransactionManager (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.orm.jdo

## Class JdoTransactionManager

- java.lang.Object
- - org.springframework.transaction.support.AbstractPlatformTransactionManager
  - - org.springframework.orm.jdo.JdoTransactionManager

- All Implemented Interfaces:
    Serializable, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

      public class JdoTransactionManager
      extends AbstractPlatformTransactionManager
      implements ResourceTransactionManager, InitializingBean

  `PlatformTransactionManager` implementation for a single JDO `PersistenceManagerFactory`. Binds a JDO PersistenceManager from the specified factory to the thread, potentially allowing for one thread-bound PersistenceManager per factory. `PersistenceManagerFactoryUtils` and `JdoTemplate` are aware of thread-bound persistence managers and participate in such transactions automatically. Using either of those (or going through a `TransactionAwarePersistenceManagerFactoryProxy` is required for JDO access code supporting this transaction management mechanism.

  This transaction manager is appropriate for applications that use a single JDO PersistenceManagerFactory for transactional data access. JTA (usually through `JtaTransactionManager`) is necessary for accessing multiple transactional resources within the same transaction. Note that you need to configure your JDO provider accordingly in order to make it participate in JTA transactions.

  This transaction manager also supports direct DataSource access within a transaction (i.e. plain JDBC code working with the same DataSource). This allows for mixing services which access JDO and services which use plain JDBC (without being aware of JDO)! Application code needs to stick to the same simple Connection lookup pattern as with `DataSourceTransactionManager` (i.e. `DataSourceUtils.getConnection(javax.sql.DataSource)` or going through a `TransactionAwareDataSourceProxy`).

  Note: To be able to register a DataSource's Connection for plain JDBC code, this instance needs to be aware of the DataSource (`setDataSource(javax.sql.DataSource)`). The given DataSource should obviously match the one used by the given PersistenceManagerFactory. This transaction manager will autodetect the DataSource that acts as "connectionFactory" of the PersistenceManagerFactory, so you usually don't need to explicitly specify the "dataSource" property.

  On JDBC 3.0, this transaction manager supports nested transactions via JDBC 3.0 Savepoints. The `AbstractPlatformTransactionManager.setNestedTransactionAllowed(boolean)` "nestedTransactionAllowed"} flag defaults to "false", though, as nested transactions will just apply to the JDBC Connection, not to the JDO PersistenceManager and its cached objects. You can manually set the flag to "true" if you want to use nested transactions for JDBC access code which participates in JDO transactions (provided that your JDBC driver supports Savepoints). Note that JDO itself does not support nested transactions! Hence, do not expect JDO access code to semantically participate in a nested transaction.

  Since:
    03.06.2003
  Author:
    Juergen Hoeller
  See Also:
    `setPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory)`, `setDataSource(javax.sql.DataSource)`, `PersistenceManagerFactory.getConnectionFactory()`, `LocalPersistenceManagerFactoryBean`, `PersistenceManagerFactoryUtils.getPersistenceManager(javax.jdo.PersistenceManagerFactory, boolean)`, `PersistenceManagerFactoryUtils.releasePersistenceManager(javax.jdo.PersistenceManager, javax.jdo.PersistenceManagerFactory)`, `JdoTemplate`, `TransactionAwarePersistenceManagerFactoryProxy`, `DataSourceUtils.getConnection(javax.sql.DataSource)`, `DataSourceUtils.releaseConnection(java.sql.Connection, javax.sql.DataSource)`, `JdbcTemplate`, `DataSourceTransactionManager`, `JtaTransactionManager`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

      `logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JdoTransactionManager()` Create a new JdoTransactionManager instance.
    `JdoTransactionManager(javax.jdo.PersistenceManagerFactory pmf)` Create a new JdoTransactionManager instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Eagerly initialize the JDO dialect, creating a default one for the specified PersistenceManagerFactory if none set.
    `protected void` | `closePersistenceManagerAfterFailedBegin(org.springframework.orm.jdo.JdoTransactionManager.JdoTransactionObject txObject)` Close the current transaction's EntityManager.
    `protected DataAccessException` | `convertJdoAccessException(javax.jdo.JDOException ex)` Convert the given JDOException to an appropriate exception from the `org.springframework.dao` hierarchy.
    `protected void` | `doBegin(Object transaction, TransactionDefinition definition)` Begin a new transaction with semantics according to the given transaction definition.
    `protected void` | `doCleanupAfterCompletion(Object transaction)` Cleanup resources after transaction completion.
    `protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
    `protected Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
    `protected void` | `doResume(Object transaction, Object suspendedResources)` Resume the resources of the current transaction.
    `protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
    `protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
    `protected Object` | `doSuspend(Object transaction)` Suspend the resources of the current transaction.
    `DataSource` | `getDataSource()` Return the JDBC DataSource that this instance manages transactions for.
    `JdoDialect` | `getJdoDialect()` Return the JDO dialect to use for this transaction manager.
    `javax.jdo.PersistenceManagerFactory` | `getPersistenceManagerFactory()` Return the PersistenceManagerFactory that this instance should manage transactions for.
    `Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g.
    `protected boolean` | `isExistingTransaction(Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
    `void` | `setAutodetectDataSource(boolean autodetectDataSource)` Set whether to autodetect a JDBC DataSource used by the JDO PersistenceManagerFactory, as returned by the `getConnectionFactory()` method.
    `void` | `setDataSource(DataSource dataSource)` Set the JDBC DataSource that this instance should manage transactions for.
    `void` | `setJdoDialect(JdoDialect jdoDialect)` Set the JDO dialect to use for this transaction manager.
    `void` | `setPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory pmf)` Set the PersistenceManagerFactory that this instance should manage transactions for.
    `protected boolean` | `shouldCommitOnGlobalRollbackOnly()` This implementation returns "true": a JDO2 commit will properly handle transactions that have been marked rollback-only at a global level.

    - ### Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

      `commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareForCommit, prepareSynchronization, prepareTransactionStatus, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.transaction.PlatformTransactionManager

      `commit, getTransaction, rollback`

- - ### Constructor Detail

    - #### JdoTransactionManager

          public JdoTransactionManager()

      Create a new JdoTransactionManager instance. A PersistenceManagerFactory has to be set to be able to use it.
      See Also:
        `setPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory)`

    - #### JdoTransactionManager

          public JdoTransactionManager(javax.jdo.PersistenceManagerFactory pmf)

      Create a new JdoTransactionManager instance.
      Parameters:
        `pmf` - PersistenceManagerFactory to manage transactions for

  - ### Method Detail

    - #### setPersistenceManagerFactory

          public void setPersistenceManagerFactory(javax.jdo.PersistenceManagerFactory pmf)

      Set the PersistenceManagerFactory that this instance should manage transactions for.

      The PersistenceManagerFactory specified here should be the target PersistenceManagerFactory to manage transactions for, not a TransactionAwarePersistenceManagerFactoryProxy. Only data access code may work with TransactionAwarePersistenceManagerFactoryProxy, while the transaction manager needs to work on the underlying target PersistenceManagerFactory.

      See Also:
        `TransactionAwarePersistenceManagerFactoryProxy`

    - #### getPersistenceManagerFactory

          public javax.jdo.PersistenceManagerFactory getPersistenceManagerFactory()

      Return the PersistenceManagerFactory that this instance should manage transactions for.

    - #### setDataSource

          public void setDataSource(DataSource dataSource)

      Set the JDBC DataSource that this instance should manage transactions for. The DataSource should match the one used by the JDO PersistenceManagerFactory: for example, you could specify the same JNDI DataSource for both.

      If the PersistenceManagerFactory uses a DataSource as connection factory, the DataSource will be autodetected: You can still explictly specify the DataSource, but you don't need to in this case.

      A transactional JDBC Connection for this DataSource will be provided to application code accessing this DataSource directly via DataSourceUtils or JdbcTemplate. The Connection will be taken from the JDO PersistenceManager.

      Note that you need to use a JDO dialect for a specific JDO provider to allow for exposing JDO transactions as JDBC transactions.

      The DataSource specified here should be the target DataSource to manage transactions for, not a TransactionAwareDataSourceProxy. Only data access code may work with TransactionAwareDataSourceProxy, while the transaction manager needs to work on the underlying target DataSource. If there's nevertheless a TransactionAwareDataSourceProxy passed in, it will be unwrapped to extract its target DataSource.

      See Also:
        `setAutodetectDataSource(boolean)`, `setJdoDialect(org.springframework.orm.jdo.JdoDialect)`, `PersistenceManagerFactory.getConnectionFactory()`, `TransactionAwareDataSourceProxy`, `DataSourceUtils`, `JdbcTemplate`

    - #### getDataSource

          public DataSource getDataSource()

      Return the JDBC DataSource that this instance manages transactions for.

    - #### setAutodetectDataSource

          public void setAutodetectDataSource(boolean autodetectDataSource)

      Set whether to autodetect a JDBC DataSource used by the JDO PersistenceManagerFactory, as returned by the `getConnectionFactory()` method. Default is "true".

      Can be turned off to deliberately ignore an available DataSource, to not expose JDO transactions as JDBC transactions for that DataSource.

      See Also:
        `setDataSource(javax.sql.DataSource)`, `PersistenceManagerFactory.getConnectionFactory()`

    - #### setJdoDialect

          public void setJdoDialect(JdoDialect jdoDialect)

      Set the JDO dialect to use for this transaction manager.

      The dialect object can be used to retrieve the underlying JDBC connection and thus allows for exposing JDO transactions as JDBC transactions.

      See Also:
        `JdoDialect.getJdbcConnection(javax.jdo.PersistenceManager, boolean)`

    - #### getJdoDialect

          public JdoDialect getJdoDialect()

      Return the JDO dialect to use for this transaction manager.

      Creates a default one for the specified PersistenceManagerFactory if none set.

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Eagerly initialize the JDO dialect, creating a default one for the specified PersistenceManagerFactory if none set. Auto-detect the PersistenceManagerFactory's DataSource, if any.
      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### getResourceFactory

          public Object getResourceFactory()

      Description copied from interface: `ResourceTransactionManager`
      Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

      This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

      Specified by:
        `getResourceFactory` in interface `ResourceTransactionManager`
      Returns:
        the target resource factory (never `null`)
      See Also:
        `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

    - #### doGetTransaction

          protected Object doGetTransaction()

      Description copied from class: `AbstractPlatformTransactionManager`
      Return a transaction object for the current transaction state.

      The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

      The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

      Specified by:
        `doGetTransaction` in class `AbstractPlatformTransactionManager`
      Returns:
        the current transaction object
      See Also:
        `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

    - #### isExistingTransaction

          protected boolean isExistingTransaction(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

      The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

      The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

      Overrides:
        `isExistingTransaction` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by doGetTransaction
      Returns:
        if there is an existing transaction
      See Also:
        `AbstractPlatformTransactionManager.doGetTransaction()`

    - #### doBegin

          protected void doBegin(Object transaction,
                     TransactionDefinition definition)

      Description copied from class: `AbstractPlatformTransactionManager`
      Begin a new transaction with semantics according to the given transaction definition. Does not have to care about applying the propagation behavior, as this has already been handled by this abstract manager.

      This method gets called when the transaction manager has decided to actually start a new transaction. Either there wasn't any transaction before, or the previous transaction has been suspended.

      A special scenario is a nested transaction without savepoint: If `useSavepointForNestedTransaction()` returns "false", this method will be called to start a nested transaction when necessary. In such a context, there will be an active transaction: The implementation of this method has to detect this and start an appropriate nested transaction.

      Specified by:
        `doBegin` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
        `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

    - #### closePersistenceManagerAfterFailedBegin

          protected void closePersistenceManagerAfterFailedBegin(org.springframework.orm.jdo.JdoTransactionManager.JdoTransactionObject txObject)

      Close the current transaction's EntityManager. Called after a transaction begin attempt failed.
      Parameters:
        `txObject` - the current transaction

    - #### doSuspend

          protected Object doSuspend(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

      The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

      Overrides:
        `doSuspend` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
      Returns:
        an object that holds suspended resources (will be kept unexamined for passing it into doResume)
      See Also:
        `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

    - #### doResume

          protected void doResume(Object transaction,
                      Object suspendedResources)

      Description copied from class: `AbstractPlatformTransactionManager`
      Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

      The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

      Overrides:
        `doResume` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`
        `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
      See Also:
        `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

    - #### shouldCommitOnGlobalRollbackOnly

          protected boolean shouldCommitOnGlobalRollbackOnly()

      This implementation returns "true": a JDO2 commit will properly handle transactions that have been marked rollback-only at a global level.
      Overrides:
        `shouldCommitOnGlobalRollbackOnly` in class `AbstractPlatformTransactionManager`
      See Also:
        `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.isGlobalRollbackOnly()`, `AbstractTransactionStatus.isLocalRollbackOnly()`, `TransactionStatus.setRollbackOnly()`, `UnexpectedRollbackException`, `UserTransaction.commit()`, `RollbackException`

    - #### doCommit

          protected void doCommit(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Perform an actual commit of the given transaction.

      An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

      Specified by:
        `doCommit` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction
      See Also:
        `DefaultTransactionStatus.getTransaction()`

    - #### doRollback

          protected void doRollback(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Perform an actual rollback of the given transaction.

      An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

      Specified by:
        `doRollback` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction
      See Also:
        `DefaultTransactionStatus.getTransaction()`

    - #### doSetRollbackOnly

          protected void doSetRollbackOnly(DefaultTransactionStatus status)

      Description copied from class: `AbstractPlatformTransactionManager`
      Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

      The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

      Overrides:
        `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
      Parameters:
        `status` - the status representation of the transaction

    - #### doCleanupAfterCompletion

          protected void doCleanupAfterCompletion(Object transaction)

      Description copied from class: `AbstractPlatformTransactionManager`
      Cleanup resources after transaction completion.

      Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

      Should not throw any exceptions but just issue warnings on errors.

      Overrides:
        `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
      Parameters:
        `transaction` - transaction object returned by `doGetTransaction`

    - #### convertJdoAccessException

          protected DataAccessException convertJdoAccessException(javax.jdo.JDOException ex)

      Convert the given JDOException to an appropriate exception from the `org.springframework.dao` hierarchy.

      The default implementation delegates to the JdoDialect. May be overridden in subclasses.

      Parameters:
        `ex` - JDOException that occured
      Returns:
        the corresponding DataAccessException instance
      See Also:
        `JdoDialect.translateException(javax.jdo.JDOException)`